var _width  = width  * window_zoom;
var _height = height * window_zoom;

draw_sprite_ext(spr_menu_icon,		 0,			 15, 10,  1,  1, 0, c_white, hover_menu       ? 1 : .5);
draw_sprite_ext(spr_sound,			 !sound_on,  50, 10, .5, .5, 0, c_white, hover_mute		  ? 1 : .5);
draw_sprite_ext(spr_fullscreen_icon, fullscreen, 90, 10,  1,  1, 0, c_white, hover_fullscreen ? 1 : .5);

#region Logo
if (timer < room_speed * 5) {
	// Fade configuration
	var _fade = room_speed * .86;
	var _end  = room_speed * 1.58 + _fade;
	
	// Fade in
	var _frac = timer / _fade;
	// Fade out
	if (timer > _end) {
		_frac = 1 - (timer - _end) / _fade;
	}
	
	// Background
	draw_set_color(logo_bg_color);
	if (timer > _end) draw_set_alpha(_frac + .3);
	draw_rectangle(0, 0, _width + 1, _height + 1, false);
	draw_set_alpha(1);
	draw_set_color(c_white);

	// High-res logo
	gpu_set_tex_filter(true);
	draw_sprite_ext(
		spr_logo_tonystr,
		0,
		_width / 2,
		_height / 2,
		1,
		1,
		0,
		c_white,
		_frac
	);
	gpu_set_tex_filter(false);
}
#endregion;

#region End credits
if (credits_timer) {
	var _scale = 1;
	var _index = min(floor(credits_timer / (room_speed * 1.7)), array_length(credits_text) - 1);
	var _alpha = 1 + dcos(credits_timer / 360);
	
	if (credits_timer > room_speed * .5 && (keyboard_check(vk_anykey) || mouse_check_button_pressed(mb_any))) {
		url_open("https://twitter.com/TonyStr_");
		game_end();
	}
	
	// Background
	draw_set_color(credits_bg_color);
	draw_set_alpha(_alpha);
	draw_rectangle(0, 0, _width + 1, _height + 1, false);
	draw_set_alpha(1);
	draw_set_color(c_white);
	
	if (_index < array_length(credits_text)) {
		draw_set_halign(fa_center);
		draw_text_transformed(_width / 2, _height / 2, credits_text[_index], _scale, _scale, 0);
		draw_set_valign(fa_middle);
	}
}
#endregion;