
timer++;
if (credits_timer) credits_timer += .6;

var _border_left   = -512;
var _border_top    = -0;
var _border_right  = instance_exists(obj_world) ? 960 * obj_world.scale_x - (width  * zoom) + 512 : 960;
var _border_bottom = instance_exists(obj_world) ? 720 * obj_world.scale_y - (height * zoom) + 0   : 720;

function toggle_fullscreen() {
	fullscreen = !fullscreen;
	window_set_fullscreen(fullscreen);
	window_zoom = 3 + fullscreen;
	window_set_size(width * window_zoom, height * window_zoom);
	surface_resize(application_surface, width * window_zoom, height * window_zoom);
	display_set_gui_size(width * window_zoom, height * window_zoom);	
}

if ((keyboard_check(vk_alt) && keyboard_check_pressed(vk_enter)) || keyboard_check_pressed(vk_f11)) {
	toggle_fullscreen();
}

if (keyboard_check(vk_control) || grip_ctrl) {
	window_set_cursor(cr_size_all);
} else {
	window_set_cursor(cr_default);
}

hover_menu = false;
hover_mute = false;
hover_fullscreen = false;
var _mx = device_mouse_x_to_gui(0);
var _my = device_mouse_y_to_gui(0);
if (_mx <= 90 + 30 && _my <= 40 && _mx >= 15 && _my >= 10) {
	window_set_cursor(cr_handpoint);
	hover_menu = _mx <= 40;
	hover_mute = _mx >= 50 && _mx <= 80;
	hover_fullscreen = _mx >= 90;
	
	if (mouse_check_button_pressed(mb_left)) {
		if (hover_menu) {
			with (obj_world) {
				toggle_menu();
			}
		}
		
		if (hover_mute) {
			sound_on = !sound_on;
			if (sound_on) {
				audio_sound_gain(bgm, bgm_gain, .3);	
			} else {
				audio_sound_gain(bgm, 0, .3)	
			}
		}
	
		if (hover_fullscreen) {
			toggle_fullscreen();
		}
	}
}

// if (keyboard_check_pressed(vk_end)) credits_timer = 1;

// if (keyboard_check_pressed(vk_home)) timer = room_speed * 5;

var _scroll = mouse_wheel_down() - mouse_wheel_up();
if (_scroll != 0 && move_to_country != noone) move_to_country = noone;
if (zoom_target >= max_zoom ? _scroll < 0 : _scroll != 0) {
	zoom_target += zoom_target * .1 * _scroll;	
	
	var _zoom_diff = zoom_target - zoom;
	zoom_x_change = device_mouse_x_to_gui(0) / window_zoom;
	zoom_y_change = device_mouse_y_to_gui(0) / window_zoom;
}

if (zoom != zoom_target) {
	var _initial_zoom = zoom;
	zoom = lerp(zoom, zoom_target, move_to_country == noone ? .2 : .06);
	var _zoom_diff = zoom - _initial_zoom;
	camera_set_view_size(camera, width * zoom, height * zoom);
	
	x += zoom_x_change * (-_zoom_diff);
	y += zoom_y_change * (-_zoom_diff);
}

if (mouse_check_button_pressed(mb_middle) || (keyboard_check(vk_control) && mouse_check_button_pressed(mb_left))) {
	grip_x = device_mouse_x_to_gui(0) / window_zoom * zoom;
	grip_y = device_mouse_y_to_gui(0) / window_zoom * zoom;
	grip_original_x = x;
	grip_original_y = y;
	gripping = true;
	grip_ctrl = keyboard_check(vk_control) && mouse_check_button_pressed(mb_left);
	move_to_country = noone;
}

if (mouse_check_button_released(mb_middle) || (grip_ctrl && mouse_check_button_released(mb_left)) || move_to_boom) {
	gripping = false;
	grip_ctrl = false;
}

if (instance_exists(obj_boom)) {
	with (obj_boom) {
		if (!player_made && !rectangle_in_rectangle(
			bbox_left,
			bbox_top,
			bbox_right,
			bbox_bottom,
	
			other.x,
			other.y,
			other.x + other.width  * other.zoom,
			other.y + other.height * other.zoom,
		)) {
			other.move_to_boom = id;	
		}
	}
}

if (move_to_boom != noone) {
	if (!instance_exists(move_to_boom)) {
		move_to_boom = noone;	
	} else {
		x = lerp(x, move_to_boom.x - width  * zoom / 2, .1);
		y = lerp(y, move_to_boom.y - height * zoom / 2, .1);
		if (point_distance(x, y, move_to_boom.x - width * zoom / 2, move_to_boom.y - height * zoom / 2) < 2) {
			move_to_boom = noone;	
		}
	}
	
	if (move_to_country != noone) move_to_country = noone;
	
} else if (move_to_country != noone) {
	if (!instance_exists(move_to_country)) {
		move_to_country = noone;	
	} else {
		x = lerp(x, move_to_country.x - width  * zoom / 2, .1);
		y = lerp(y, move_to_country.y - height * zoom / 2, .1);
		
		var _path = move_to_country.paths[move_to_country.biggest_path];
		var _country_width = (_path.right - _path.left) * move_to_country.scale_x;
			
		zoom_target = min(_country_width / (width * .2), max_zoom);
		zoom_x_change = (move_to_country.x - x) / zoom;
		zoom_y_change = (move_to_country.y - y) / zoom;
		
		if (
			point_distance(x, y, move_to_country.x - width * zoom / 2, move_to_country.y - height * zoom / 2) < 2 ||
			(
				x <= _border_left   + 1 ||
				y <= _border_top    + 1 ||
				x >= _border_right  - 1 ||
				y >= _border_bottom - 1
			) ||
			(zoom_target > max_zoom && zoom >= max_zoom - .1)
		) {
			move_to_country = noone;
		}
	}

} else if (!hover_mute && !hover_fullscreen && !(instance_exists(obj_world) && (obj_world.escape_menu_visible || obj_world.initial_boom))) {
	var _region = 64;
	var _rate = .8;
	
	var _mx = device_mouse_x_to_gui(0);
	var _my = device_mouse_y_to_gui(0);
	if (_mx < 0 || _mx > width  * window_zoom) _mx = _region + 50;
	if (_my < 0 || _my > height * window_zoom) _my = _region + 50;
	
	if (_mx < _region) x -= (_region - _mx) * _rate;
	if (_mx > width * window_zoom - _region) x += _region * _rate - (width * window_zoom - _mx) * _rate;
	if (_my < _region) y -= (_region - _my) * _rate;
	if (_my > height * window_zoom - _region) y += _region * _rate - (height * window_zoom - _my) * _rate;
}

if (gripping) {
	// grip_x = mouse_x;
	// grip_y = mouse_y;
	x = grip_original_x + grip_x - device_mouse_x_to_gui(0) / window_zoom * zoom;
	y = grip_original_y + grip_y - device_mouse_y_to_gui(0) / window_zoom * zoom;
}

if (instance_exists(obj_world)) {
	x = median(x, _border_left, _border_right);
	y = median(y, _border_top,  _border_bottom);
}

camera_set_view_pos(
	camera,
	x,
	y
);