
name = "undefined";
name_prefix = "";
code = "undefined";
color = $ff00ff;
paths = [];

scale_x = 1;
scale_y = 1;
offset_x = 0;
offset_y = -80;

outline = true;

hover = false;
hover_path = undefined;
hover_timer = 0;

drawn = false;

pressing = false;
aiming = false;
aiming_timer = 0;

from_x = 0;
from_y = 0;

target_x = 0;
target_y = 0;

nuke_control = noone;

nuked = false;

suspect = false;

points = 250 + irandom(10) * 100 + irandom(1) * 50;

biggest_path = -1;
biggest_path_size = 0;

function find_path_size(_path) {
	var _vertices = _path.verticies;
	var _triangles = _path.triangles;
	var _triangles_len = array_length(_triangles);
	
	var _acc = 0;
	for (var i = 0; i < _triangles_len; i += 3) {
		var _index1 = _triangles[i];
		var _index2 = _triangles[i + 1];
		var _index3 = _triangles[i + 2];
		// var _tcx = mean(_vertices[_index1 * 2], _vertices[_index2 * 2], _vertices[_index3 * 2]);
		// var _tcy = mean(_vertices[_index1 * 2 + 1], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2 + 1]);
		var _a = point_distance(_vertices[_index1 * 2], _vertices[_index1 * 2 + 1], _vertices[_index2 * 2], _vertices[_index2 * 2 + 1]);
		var _b = point_distance(_vertices[_index2 * 2], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2], _vertices[_index3 * 2 + 1]);
		var _c = point_distance(_vertices[_index3 * 2], _vertices[_index3 * 2 + 1], _vertices[_index1 * 2], _vertices[_index1 * 2 + 1]);
		var _s = (_a + _b + _c) / 2;
		if (_s * (_s - _a) * (_s - _b) * (_s - _c) <= 0) continue;
		var _area = sqrt(_s * (_s - _a) * (_s - _b) * (_s - _c));
			
		_acc += _area;
	}
	return _acc;
}

function find_path_center(_path) {
	var _vertices = _path.verticies;
	var _triangles = _path.triangles;
	var _triangles_len = array_length(_triangles);
	var _closest = 1000000;
	var _closest_x = 0;
	var _closest_y = 0;
	var _x = (_path.left + _path.right) / 2;
	var _y = (_path.top + _path.bottom) / 2;
	
	if (check_collision(_x * scale_x + offset_x, _y * scale_y + offset_y)) {
		for (var i = 0; i < _triangles_len; i += 3) {
			var _index1 = _triangles[i];
			var _index2 = _triangles[i + 1];
			var _index3 = _triangles[i + 2];
			var _tcx = mean(_vertices[_index1 * 2], _vertices[_index2 * 2], _vertices[_index3 * 2]);
			var _tcy = mean(_vertices[_index1 * 2 + 1], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2 + 1]);
			var _dis = point_distance(_tcx, _tcy, _x, _y) 
			
			if (_dis < _closest) {
				_closest = _dis;
				_closest_x = _tcx;
				_closest_y = _tcy;
			}
		}
		_x = _closest_x;
		_y = _closest_y;
	} else {
		var _biggest = 0;
		for (var i = 0; i < _triangles_len; i += 3) {
			var _index1 = _triangles[i];
			var _index2 = _triangles[i + 1];
			var _index3 = _triangles[i + 2];
			// var _tcx = mean(_vertices[_index1 * 2], _vertices[_index2 * 2], _vertices[_index3 * 2]);
			// var _tcy = mean(_vertices[_index1 * 2 + 1], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2 + 1]);
			var _a = point_distance(_vertices[_index1 * 2], _vertices[_index1 * 2 + 1], _vertices[_index2 * 2], _vertices[_index2 * 2 + 1]);
			var _b = point_distance(_vertices[_index2 * 2], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2], _vertices[_index3 * 2 + 1]);
			var _c = point_distance(_vertices[_index3 * 2], _vertices[_index3 * 2 + 1], _vertices[_index1 * 2], _vertices[_index1 * 2 + 1]);
			var _s = (_a + _b + _c) / 2;
			var _area = sqrt(_s * (_s - _a) * (_s - _b) * (_s - _c));
			
			if (_area > _biggest) {
				_biggest = _area;
				_x = mean(_vertices[_index1 * 2], _vertices[_index2 * 2], _vertices[_index3 * 2]);
				_y = mean(_vertices[_index1 * 2 + 1], _vertices[_index2 * 2 + 1], _vertices[_index3 * 2 + 1]);
			}
		}
	}
	
	return [_x, _y];
}


function check_collision(_x, _y) {
	var _paths_count = array_length(paths);
	for (var _pathi = 0; _pathi < _paths_count; _pathi++) {
		var _path = paths[_pathi];
		var _vertices  = _path.verticies;
		var _triangles = _path.triangles;
	
		// Optimization
		if (!point_in_rectangle(
			_x,
			_y,
			_path.left   * scale_x + offset_x,
			_path.top    * scale_y + offset_y,
			_path.right  * scale_x + offset_x,
			_path.bottom * scale_y + offset_y
		)) { 
			continue;
		}
		
		var _triangles_len = array_length(_triangles);
		if (_triangles_len != 0) {
			for (var i = 0; i < _triangles_len; i += 3) {
				var _p = [
					_vertices[_triangles[i    ] * 2] * scale_x + offset_x, _vertices[_triangles[i    ] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 1] * 2] * scale_x + offset_x, _vertices[_triangles[i + 1] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 2] * 2] * scale_x + offset_x, _vertices[_triangles[i + 2] * 2 + 1] * scale_y + offset_y,
				];
			
				if (point_in_triangle(
					_x,
					_y,
					_p[0], _p[1],
					_p[2], _p[3],
					_p[4], _p[5]
				)) {
					return true;
				}
			}
		} else {
			// Assumed noise
			//var _vertices_len = array_length(_vertices);
			//draw_primitive_begin(pr_linestrip);
			//for (var i = 0; i < _vertices_len; i += 2) {
			//	draw_vertex(_vertices[i], _vertices[i + 1]);
			//}
			//draw_primitive_end();
			//
			//draw_circle(_vertices[0], _vertices[1], 16, true);
		}
	}	
	
	return false;
}