
// draw_circle(x, y, 16, true);

var _zoom_margin = obj_camera.zoom_margin;
var _draw_bco_zoom = obj_camera.zoom < _zoom_margin;
var _zoom = obj_camera.zoom;
// Draw country
if (!(drawn && !hover) || _draw_bco_zoom || (suspect && obj_suspects_effects.show_suspects)) {
	var _sus_pulse = 0;
	var _color = color;
	var _outline_color = $5a5370;
	if (!drawn) {
		if (!surface_exists(obj_world.world_surface)) {
			obj_world.world_surface = surface_create(
				obj_world.scale_x * 960,
				obj_world.scale_y * 720,
			);
			surface_set_target(obj_world.world_surface);
			draw_clear_alpha(c_white, 0);
			surface_reset_target();
		}
		surface_set_target(obj_world.world_surface);
		_color = $9696aa;
		_zoom = obj_camera.default_zoom;
	}
	
	if (_draw_bco_zoom && !hover) {
		_color = $9696aa;
	}
	
	if (nuked) {
		_color = $4f404e;
		_outline_color = $3a2f2c;
	}
	
	var _paths_count = array_length(paths);

	var _line_size = hover && drawn ? 
		_zoom * ((sin(hover_timer / 6) + 2) / 2) : 
		(drawn ? _zoom / 2 : _zoom / 3);
		
	if (suspect) {
		_sus_pulse = median(sin(obj_suspects_effects.timer / 18) + .3, 0, 1);
		_color = merge_color($9696aa, $1000fc, _sus_pulse);
		_outline_color = merge_color($5a5370, $3a2f2c, _sus_pulse);
		_line_size = _zoom / 3 + _zoom * _sus_pulse;
	}
	
	for (var _pathi = 0; _pathi < _paths_count; _pathi++) {
		var _path = paths[_pathi];
		var _vertices  = _path.verticies;
		var _triangles = _path.triangles;
	
		// Optimization
		if (rectangle_in_rectangle(
			obj_camera.x,                                   
			obj_camera.y,                                      
			obj_camera.x + obj_camera.width  * _zoom,
			obj_camera.y + obj_camera.height * _zoom,
		
			_path.left   * scale_x + offset_x,
			_path.top    * scale_y + offset_y,
			_path.right  * scale_x + offset_x,
			_path.bottom * scale_y + offset_y
		) < 1 && drawn) { 
			continue;
		}
	
	
		if (name == undefined) {
			draw_set_color(c_red);
			draw_circle(_path.left * scale_x + offset_x, _path.top * scale_y + offset_y, 40, true);	
			draw_set_color(c_white);
		}
	
		// var _debug_color = c_white;
		// draw_rectangle(
		// 	_path.left   * scale_x + offset_x,
		// 	_path.top    * scale_y + offset_y,
		// 	_path.right  * scale_x + offset_x,
		// 	_path.bottom * scale_y + offset_y,
		// 	_debug_color
		// );
		
		var _triangles_len = array_length(_triangles);
		if (_triangles_len != 0) {
			for (var i = 0; i < _triangles_len; i += 3) {
				var _p = [
					_vertices[_triangles[i    ] * 2] * scale_x + offset_x, _vertices[_triangles[i    ] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 1] * 2] * scale_x + offset_x, _vertices[_triangles[i + 1] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 2] * 2] * scale_x + offset_x, _vertices[_triangles[i + 2] * 2 + 1] * scale_y + offset_y,
				];
			
				draw_triangle_color(
					_p[0], _p[1],
					_p[2], _p[3],
					_p[4], _p[5],
					_color, _color, _color,
					false
				);
				//draw_vertex_color(_vertices[_triangles[i    ] * 2] * scale_x + offset_x, _vertices[_triangles[i    ] * 2 + 1] * scale_y + offset_y, color, 1);
				//draw_vertex_color(_vertices[_triangles[i + 1] * 2] * scale_x + offset_x, _vertices[_triangles[i + 1] * 2 + 1] * scale_y + offset_y, color, 1);
				//draw_vertex_color(_vertices[_triangles[i + 2] * 2] * scale_x + offset_x, _vertices[_triangles[i + 2] * 2 + 1] * scale_y + offset_y, color, 1);
			}
			
			if (outline) {
				var _vertices_len = array_length(_vertices);
				for (var i = 0; i <= _vertices_len; i += 2) {
					var _index = i % _vertices_len;
					draw_sprite_line(
						_vertices[_index    ] * scale_x + offset_x, 
						_vertices[_index + 1] * scale_y + offset_y,
						_vertices[(_index + 2) % _vertices_len] * scale_x + offset_x, 
						_vertices[(_index + 3) % _vertices_len] * scale_y + offset_y,
						_line_size,
						hover && drawn ? $ffffff : _outline_color, //$352722
						1
					);
				}
			}
		} else {
			// show_debug_message("Noise found in " + code);
			
			// var _vertices_len = array_length(_vertices);
			// for (var i = 0; i <= _vertices_len; i += 2) {
			// 	var _index = i % _vertices_len;
			// 	draw_sprite_line(
			// 		_vertices[_index    ] * scale_x + offset_x, 
			// 		_vertices[_index + 1] * scale_y + offset_y,
			// 		_vertices[(_index + 2) % _vertices_len] * scale_x + offset_x, 
			// 		_vertices[(_index + 3) % _vertices_len] * scale_y + offset_y,
			// 		_line_size,
			// 		hover && drawn ? $ffffff : _outline_color, //$352722
			// 		1
			// 	);
			// }
			// Assumed noise
			//var _vertices_len = array_length(_vertices);
			//draw_primitive_begin(pr_linestrip);
			//for (var i = 0; i < _vertices_len; i += 2) {
			//	draw_vertex(_vertices[i], _vertices[i + 1]);
			//}
			//draw_primitive_end();
			//
			//draw_circle(_vertices[0], _vertices[1], 16, true);
		}
	}

	if (!drawn) {
		surface_reset_target();
		drawn = true;
	}
	
	if (_draw_bco_zoom) {
		draw_set_halign(fa_center);
		draw_set_valign(fa_middle);
		draw_set_color($5a5370);
		draw_set_alpha((_zoom_margin - _zoom) * 2);
		draw_text_transformed(x, y, code, _zoom / 6, _zoom / 6, 0);	//  + " " + string(biggest_path_size)
		draw_set_alpha(1);
		draw_set_color(c_white);
		draw_set_halign(fa_top);
		draw_set_valign(fa_left);
	}
}
	
if (aiming) {
	var _diffic = obj_camera.aiming_difficulty
	var _height = 80 * obj_camera.zoom;
	var _zoom = obj_camera.zoom;
	var _red = $1000fc;
	var _red_bg = $4f404e;
	
	var _cross_scl = _zoom / 8;
	// Draw cross
	draw_sprite_ext(
		spr_cross,
		0,
		from_x,
		from_y + _zoom * 1,
		_cross_scl,
		_cross_scl * .6,
		0,
		_red_bg,
		1
	);
	draw_sprite_ext(
		spr_cross,
		0,
		from_x,
		from_y,
		_cross_scl,
		_cross_scl * .6,
		0,
		_red,
		1
	);
	
	// Draw nuke arc
	var _count = 8;
	var _max = _count + 1;
	for (var i = 0; i < _max; i++) {
		var _p1 = (i +      aiming_timer / 70) % _max;
		var _p2 = (i + .5 + aiming_timer / 70) % _max;
		
		if (_p1 < 1) _p1 = 1;
		if (_p2 > _count) _p2 = _count;
		if (_p1 > _p2) continue;
		
		var _p1frac = (_p1 - 1) / (_count - 1);
		var _p2frac = (_p2 - 1) / (_count - 1);
		
		var _sin1 = dsin(_p1frac * 180);
		var _sin2 = dsin(_p2frac * 180);
		
		
		draw_sprite_line(
			lerp(from_x, target_x, _p1frac),
			lerp(from_y, target_y, _p1frac) - _sin1 * _height + _zoom * 1,
			lerp(from_x, target_x, _p2frac),
			lerp(from_y, target_y, _p2frac) - _sin2 * _height + _zoom * 1,
			_zoom * 2,
			_red_bg,
			1 - (_p1 + (_diffic - 5) * .8 - 1) / (_count - 1)
		);
		
		draw_sprite_line(
			lerp(from_x, target_x, _p1frac),
			lerp(from_y, target_y, _p1frac) - _sin1 * _height,
			lerp(from_x, target_x, _p2frac),
			lerp(from_y, target_y, _p2frac) - _sin2 * _height,
			_zoom * 1.5,
			_red,
			1 - (_p1 + (_diffic - 5) * .6 - 2.6) / (_count - 1)
		);
	}
	
	// Draw dotts
	if (pressing) {
		var _dots = 3;
		var _scale = obj_camera.zoom / 5;
		for (var i = 0; i < _dots; i++) {
			var _x = lerp(mouse_x, from_x, i / _dots);
			var _y = lerp(mouse_y, from_y, i / _dots);
		
			draw_sprite_ext(spr_circle, 0, _x, _y, _scale, _scale, 0, c_white, 1 - min((_diffic / 5) * .5, .5));
		}
	}
}

