
x = 0;
y = 0;

scale_x = 8;
scale_y = 8;
offset_x = 0;
offset_y = 0;

countries = json_load("country_paths.json");

world_surface = -1;

function findPathEdges(_path) {
	var _vertices = _path.verticies;
	var _top    = _vertices[1];
	var _left   = _vertices[0];
	var _bottom = _vertices[1];
	var _right  = _vertices[0];
	
	var _vertices_len = array_length(_vertices);
	for (var i = 2; i < _vertices_len; i += 2) {
		var _x = _vertices[i];
		var _y = _vertices[i + 1];
		
		if (_x < _left  ) _left   = _x;
		if (_y < _top   ) _top    = _y;
		if (_x > _right ) _right  = _x;
		if (_y > _bottom) _bottom = _y;
	}
	
	_path.left   = _left;
	_path.top    = _top;
	_path.right  = _right;
	_path.bottom = _bottom;
	
	return _path;
}

random(360);

escape_menu_visible = false;
escape_menu_visible_actual_message = false;
function toggle_menu() {
	escape_menu_visible = !escape_menu_visible;
	mouse_locked = escape_menu_visible;
	with (obj_country) {
		aiming = false;
	}
}

remaining_countries = [];
auto_nuke_countdown = room_speed * 8 * 3; // *3 because of speady countdown
victim = noone;
auto_nuke_timer = 0;
auto_nuke_menu_countdown = 0;
auto_nuke_menu_countdown_fast = false;
auto_nuke_menu_timer = 0;
suspects = [];
mouse_locked = true;
hover = false;
initial_boom = true;

space_hint_timer = 0;
space_hint_countdown = 0;
space_hint_time = floor(room_speed * .18);

banner_string = "";
banner_timer = 0;

// Create country objects
var _size = array_length(countries);
for (var _ci = 0; _ci < _size; _ci ++) {
	var _country_data = countries[_ci];
	with (instance_create_depth(x, y, depth - 10, obj_country)) {
		color = make_color_hsv(random(360), 60 + random(60), 230 + random(20));
		code  = _country_data.code;
		paths = _country_data.paths;
		name = _country_data.name;
		name_prefix = _country_data.name_prefix;
		
		var _biggest_path = 0;
		var _biggest_path_size = 0;
		var _paths_len = array_length(paths);
		for (var i = 0; i < _paths_len; i++) {
			var _path = findPathEdges(paths[i]);
			paths[i] = _path;
			
			var _path_size = (_path.right - _path.left) * (_path.bottom - _path.top);
			if (_path_size > _biggest_path_size) {
				_biggest_path_size = _path_size;
				_biggest_path = i;
			}
		}
		
		scale_x  = other.scale_x;
		scale_y  = other.scale_y;
		offset_x = other.offset_x;
		offset_y = other.offset_y;
		
		#region Calculate x/y
		
		biggest_path = _biggest_path;
		biggest_path_size = find_path_size(paths[_biggest_path]);
		var _center = find_path_center(paths[_biggest_path]);
		
		// Dropping Lechutes (LS) because of overlap with country behind it. No time to fix now.
		if (biggest_path_size > 0.6 && code != "LS") { // 0.1
			array_push(other.remaining_countries, id);
			show_debug_message(name);
		}
		
		x = _center[0] * scale_x + offset_x;
		y = _center[1] * scale_y + offset_y;
		
		if (code == "CA") {
			x -= 100;
			y += 100;
		}
		
		#endregion;
		
	}
}